unit SMDialog;

interface

uses WinTypes, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls, Dialogs;

type
  TSparseMatrixDlg = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    Bevel1: TBevel;
    RadioGroup1: TRadioGroup;
    RowEdit: TEdit;
    ColEdit: TEdit;
    ValueEdit: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure RowEditChange(Sender: TObject);
    procedure ColEditChange(Sender: TObject);
    procedure ValueEditChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  SparseMatrixDlg: TSparseMatrixDlg;

implementation

{$R *.DFM}

procedure TSparseMatrixDlg.RowEditChange(Sender: TObject);
var i: integer;
    ErrorOc: boolean;
begin
      ErrorOc:= false;
      if RowEdit.Text <> '' then
      begin
      try
      i:= StrToInt(RowEdit.Text);
      Except on EConvertError do ErrorOc:= true;
      end;
      if (ErrorOc = true) then ShowMessage('Invalid number of rows!')
      end;
end;

procedure TSparseMatrixDlg.ColEditChange(Sender: TObject);
var i: integer;
    ErrorOc: boolean;
begin
      ErrorOc:= false;
      if ColEdit.Text <> '' then
      begin
      try
      i:= StrToInt(ColEdit.Text);
      Except on EConvertError do ErrorOc:= true;
      end;
      if (ErrorOc = true) then ShowMessage('Invalid number of columns!')
      end;
end;

procedure TSparseMatrixDlg.ValueEditChange(Sender: TObject);
var x: extended;
    ErrorOc: boolean;
begin
      ErrorOc:= false;
      if ValueEdit.Text <> '' then
      begin
      try
      x:= StrToFloat(ColEdit.Text);
      Except on EConvertError do ErrorOc:= true;
      end;
      if (ErrorOc = true) then ShowMessage('Invalid number!')
      end;
end;

procedure TSparseMatrixDlg.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
     if RowEdit.Text = '' then RowEdit.Text:= '1';
     if ColEdit.Text = '' then ColEdit.Text:= '1';
     if ValueEdit.Text = '' then ValueEdit.Text:= '0';
end;

end.
